Debian Bug report logs - #236721
RFP: squeak -- programming system, with educational applets

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Kurt Gramlich <kurt@lugrav.de>

Date: Sun, 7 Mar 2004 22:18:01 UTC

Severity: wishlist

Done: David Moreno Garza <damog@merkel.debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Kurt Gramlich <kurt@lugrav.de>:
New Bug report received and forwarded. Copy sent to wnpp@debian.org. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Kurt Gramlich <kurt@lugrav.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: RFP: squeak -- A programming system, with some delightful and powerful educational applets.
Date: Sat, 06 Mar 2004 22:48:31 +0100
Package: wnpp
Version: N/A; reported 2004-03-06
Severity: wishlist

* Package name    : squeak
  Version         : 3.6
  Upstream Author : Name <somebody@some.org>
* URL             : http://www.squeak.org/
* License         : Apple Computer, Inc. Software License http://www.squeak.org/download/license.html
  Description     : A programming system, with some delightful and powerful educational applets.

We need this kind of software for skolelinux/debian-edu

-- System Information
Debian Release: 3.0
Architecture: i386




Message sent on to Kurt Gramlich <kurt@lugrav.de>:
Bug#236721. Full text and rfc822 format available.

Message #8 received at 236721-submitter@bugs.debian.org (full text, mbox):

From: Roland Stigge <stigge@antcom.de>
To: debian-legal@lists.debian.org
Cc: 236721-submitter@bugs.debian.org
Subject: Squeak in Debian?
Date: Thu, 22 Apr 2004 14:11:21 +0200
[Sorry, resending previously unfinished report.]

Hi,

today I read that Alan Kay will receive this years's Turing Award[1] and
checked out his "Open Source" project Squeak[2]. I also realized that
there is an open RFP for it[3]. The package is supposed to be free, but
when I checked the license[4] and the package files, I encountered the
following issues which should be resolved before squeak hits the
archive:

(1) Clause 2 states: 'You may modify and create derivative works of the
Apple Software ("Modified Software"), however, you may not modify or
create derivative works of the fonts provided by Apple ("Fonts").'

This seems to violate DFSG.3 ("Derived Works").

(2) Clause 2 also states: "You may distribute and sublicense the Fonts
only as a part of and for use with Modified Software, and not as a part
of or for use with Modified Software that is distributed or sublicensed
for a fee or for other valuable consideration."

This seems to violate DFSG.1 ("Free Redistribution").

(3) Clause 6 states: "You may not use or otherwise export or reexport
the Apple Software except as authorized by United States law and the
laws of the jurisdiction in which the Apple Software was obtained. In
particular, but without limitation, the Apple Software may not be
exported or reexported (i) into (or to a national or resident of) any
U.S. embargoed country [...]"

Which seems to violate DFSG.5 ("No Discrimination Against Persons or
Groups") since it explicitly excludes people in countries like Cuba (?)
from receiving copies of this package. I don't think we can maintain a
list of countries which the USA enforce an embargo on at a time.

(4) The distributed files squeak.changes and squeak.image, both around
10MB, are shipped in binary form. I wonder if there should be source
code to create them initially. (See DFSG.2, "Source Code")

Thanks for considering.

bye,
  Roland

[1] http://www.heise.de/newsticker/meldung/46712 (sorry, German)
[2] http://www.squeak.org/
[3] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=236721
[4] http://www.squeak.org/download/license.html




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Roland Stigge <stigge@antcom.de>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #13 received at 236721@bugs.debian.org (full text, mbox):

From: Roland Stigge <stigge@antcom.de>
To: 236721@bugs.debian.org
Subject: Squeak in Debian
Date: Thu, 22 Apr 2004 14:16:38 +0200
Hi,

before squeak hits the archives, some legal issues should be resolved. I
listed them in the following debian-legal article:

http://lists.debian.org/debian-legal/2004/debian-legal-200404/msg00159.html

bye,
  Roland




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Roland Stigge <stigge@antcom.de>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #18 received at 236721@bugs.debian.org (full text, mbox):

From: Roland Stigge <stigge@antcom.de>
To: 236721@bugs.debian.org
Subject: Squeak in Debian
Date: Fri, 23 Apr 2004 13:37:27 +0200
Hi,

before anyone else tries to package this software himself, feel free to
contact Lex Spoon, who already maintains Debian packages of Squeak. See
also
http://lists.debian.org/debian-legal/2004/debian-legal-200404/msg00170.html

bye,
  Roland




Message sent on to Kurt Gramlich <kurt@lugrav.de>:
Bug#236721. Full text and rfc822 format available.

Message #21 received at 236721-submitter@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: 236721-submitter@bugs.debian.org
Cc: Roland Stigge <stigge@antcom.de>
Subject: Re: RFP: squeak -- A programming system, with some delightful and powerful educational applets.
Date: Fri, 01 Jul 2005 17:46:39 +0200
According to
<URL:http://lists.debian.org/debian-legal/2004/04/msg00352.html>, the
non-free fonts have been replaced with free fonts.  If this is the
case, the package should be able to go into debian main.



Changed Bug title. Request was from Marcela Tiznado <mtiznado@linux.org.ar> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Ben Armstrong <synrg@sanctuary.nslug.ns.ca>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #28 received at 236721@bugs.debian.org (full text, mbox):

From: Ben Armstrong <synrg@sanctuary.nslug.ns.ca>
To: lex@debian.org
Cc: 236721@bugs.debian.org, Roland Stigge <stigge@antcom.de>, Petter Reinholdtsen <pere@hungry.com>
Subject: Squeak in Debian main
Date: Fri, 09 Jun 2006 08:59:26 -0300
Lex,

I had hoped, as Petter suggested in the Squeak RFP #236721, that Squeak
could now go into Debian main because the font issues have been
resolved, as Debian Jr. would like to include Squeak in the
junior-programming metapackage.  However, it seems Roland's points here
are not yet addressed in the RFP:

(3) Clause 6 states: "You may not use or otherwise export or reexport
the Apple Software except as authorized by United States law and the
laws of the jurisdiction in which the Apple Software was obtained. In
particular, but without limitation, the Apple Software may not be
exported or reexported (i) into (or to a national or resident of) any
U.S. embargoed country [...]"

Which seems to violate DFSG.5 ("No Discrimination Against Persons or
Groups") since it explicitly excludes people in countries like Cuba (?)
from receiving copies of this package. I don't think we can maintain a
list of countries which the USA enforce an embargo on at a time.

(4) The distributed files squeak.changes and squeak.image, both around
10MB, are shipped in binary form. I wonder if there should be source
code to create them initially. (See DFSG.2, "Source Code")


Has any progress been made with these last remaining issues?  I notice
that we list this software as unpackageable due to license issues, yet
the RFP remains on the books, which leaves the situation ambiguous.

http://www.us.debian.org/devel/wnpp/unable-to-package

Ben



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Ben Armstrong <synrg@sanctuary.nslug.ns.ca>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #33 received at 236721@bugs.debian.org (full text, mbox):

From: Ben Armstrong <synrg@sanctuary.nslug.ns.ca>
To: 236721@bugs.debian.org
Cc: lex@debian.org, Roland Stigge <stigge@antcom.de>, Petter Reinholdtsen <pere@hungry.com>
Subject: Re: Squeak in Debian main
Date: Fri, 09 Jun 2006 10:21:48 -0300
This looks like a step in the right direction:

http://lists.squeakfoundation.org/pipermail/squeak-dev/2006-May/104466.html

Although it has been noted in this thread that historically Debian has
removed APSL2 packages, and that therefore BSD/MIT would be better. 
Also, it's one thing to get approval from the Squeak board, and quite
another to actually do the work of putting together a relicensed
distribution.  So it seems all we can do now is wait and see.

Now, the question is, in light of this recent development, should Squeak
be removed from the "cannot be packaged" list, or would that be premature?

Also, Lex, in light of the fact that you have packages already (albeit
for the non-DFSG version) and Squeak seems to be moving towards a
solution, is it time to change the RFP to an ITP?

Regards,
Ben



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to "Lex Spoon" <lex@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #38 received at 236721@bugs.debian.org (full text, mbox):

From: "Lex Spoon" <lex@debian.org>
To: Ben Armstrong <synrg@sanctuary.nslug.ns.ca>, 236721@bugs.debian.org, Roland Stigge <stigge@antcom.de>, Petter Reinholdtsen <pere@hungry.com>, Matej Kosik <kosik@fiit.stuba.sk>
Subject: Re: Squeak in Debian main
Date: Fri, 9 Jun 2006 15:23:09 +0200
Ben,


Ambiguity is the proper status for this RFP.  While it remains so,
people should use the external Squeak/Debian distribution.  It is
described as follows:

http://minnow.cc.gatech.edu/squeak/3616

I am in the process of transfering maintainership to Matej Kosik
(kosik@fiit.stuba.sk).  He (or whoever he says) should be the main point
person for future discussions of Squeak's Debian packages.  While I
think Debian should include Squeak in its distribution, I do not have
time to champion that cause on the mailing lists and bug trackers.


On the RFP itself, as far as I can tell, Squeak-L fits the spirit of
DFSG, but I did not argue the case.  Instead, I argued that Squeak-L is
suitable for distribution in non-free, but even there there was debate. 
I spent considerable time on debian-legal, but the arguments went in
circles.  Here is the main thread as best I can remember:

http://lists.debian.org/debian-legal/2004/04/msg00160.html


The following page has my notes about the discussion on debian-legal:

http://minnow.cc.gatech.edu/squeak/3733

The one new item since that page's status is that Squeak 1.1 is now
available under APSL.  This provides a separate avenue for getting some
versions of Squeak into Debian proper.

http://lists.squeakfoundation.org/pipermail/squeak-dev/2006-May/104466.h
tml


I will append the current summary from Swiki page 3733 cited above, just
so that they are recorded on the bug log.   -Lex

--- below this line comes from Squeak Swiki page 3733 ----

This page summarizes the debate on whether Squeak will go into Debian
non-free. If it does go in, then this page will probably be added to the
package for future reference. If it does not go in, then this page will
be posted to debian-legal for the archives.

Please post any comments, questions, or objections at the bottom of the
page, or even better, comment to the debian-legal mailing list. This
way, the main content of the page has a single editor.

Nothing on this page is official in any way; it is just one person's
attempt to summarize the state of the discussion.

Status
As of April 30, 2004, Squeak is not included in Debian. Debian users can
still obtain packages for Squeak as described on Squeak for Debian
Users. There is some discussion on the debian-legal mailing list about
whether Squeak may be distributed in Debian non-free.

Non-Free versus Main
Some clauses of the Squeak-L seem to violate the DFSG. Most notably, the
export clause is an issue. Thus, while most agree that Squeak is an
extremely free and permissive license, it is not suitable for
Debian/main. Thus, the current discussion is on whether Debian will
include Squeak in non-free. To do this, Squeak-L must provide sufficient
premission, it must impose sufficiently few requirements, and it must
incur sufficiently low liability.

Issues on Particular Parts of the License
Export Restrictions
Squeak-L requires that any distribution of Squeak follows US Export Law.

Since Squeak does not include any cryptographic software, the main
requirement seems to be that Squeak not be distributed to countries
embargoed by the US.

It is still being discussed whether Debian can enforce this
satisfactorily. It has been noted that some Debian servers might already
be enforcing the restriction, but there is as yet no verification on
which servers those are.

It has been argued that mirrors of US-based servers still need to have
the same protections as the US-based servers, anyway, because US law
makes it illegal to export to someone who will then reexport to an
embargoed country. Thus we may want to adjust our servers anyway to
disallow downloads from embargoed countries.

Summary: open issue


Indemnification
In some circumstances, the license requires people who distribute
Squeak, to reimburse Apple for legal fees accrued in response to
litigation involving the distribution. However, the liability is
carefully tailored to restrict the liability: Debian would only be
liable for legal fees to the extent a suit is related to Debian's
distribution of Squeak.

Additionally, it is extremely unlikely that Apple will be sued over
Squeak at all, much much less in any way that involves Debian's
distribution of Squeak. If someone has a problem with Debian
distributing Squeak, then they are much more likely to sue Debian
directly. In fact, if someone does sue Apple over Debian's distribution,
then Apple must give Debian an offer to defend the case themselves if
they prefer; if Apple does not offer this opportunity, then Apple cannot
request legal fees.


summary: open issue

Computers under Direct Use
The license contains this text:
"2. Permitted Uses and Restrictions. This License allows you to copy,
install and use the Apple Software on an unlimited number of computers
under your direct control."

Two people have claimed that this renders Squeak non-distributable by
Debian, but the reasoning is unclear to this editor. The counterargument
is that this sentence merely grants permissions, and thus cannot be
removing permissions; two sentences later, the following text appears,
which is a good basis for having permission to distribute Squeak:

"You may distribute and sublicense such Modified Software only under the
terms of a valid, binding license that makes no representations or
warranties on behalf of Apple, and is no less protective of Apple and
Apple's rights than this License."

Furthermore, the "plain English license terms" (see Squeak-L) that Apple
posted seem to mean that they interpret their license as providing wide
permission to redistribute Squeak.

summary: open issue


Fonts
Squeak-L does not allow the included fonts to be modified or to be
included in a for-profit product. This is a non-issue, however, since it
is planned to remove these fonts before distributing Squeak in Debian.

summary: no problem



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to "Andreas Kuckartz" <A.Kuckartz@ping.de>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #43 received at 236721@bugs.debian.org (full text, mbox):

From: "Andreas Kuckartz" <A.Kuckartz@ping.de>
To: "Ben Armstrong" <synrg@sanctuary.nslug.ns.ca>, 236721@bugs.debian.org
Cc: lex@debian.org, "Roland Stigge" <stigge@antcom.de>, "Petter Reinholdtsen" <pere@hungry.com>
Subject: Re: Bug#236721: Squeak in Debian main
Date: 9 Jun 2006 19:10:44 +0200
> (4) The distributed files squeak.changes and squeak.image, both around
> 10MB, are shipped in binary form. I wonder if there should be source
> code to create them initially. (See DFSG.2, "Source Code")

The .changes file contains Smalltalk source code (if the system is not
broken!).

I think that one can argue that there exists nothing really comparable
to the .image files used by Smalltalk-80 systems for other programming
languages. Those .image-files exist since at least 25 years and in my
opinion they are an important aspect of the Smalltalk-80 way of doing
things. In some way it is comparable to a living organism.

And - in contrast to most other languages - the Smalltalk parser,
compiler and even major parts of the virtual Squeak machine are
implemented in Smalltalk and not in another language.

From the man page for Squeak:

"The  file squeak.image holds the objects representing the entire 
state  of  your world,  including  things such as open windows, a class
hierarchy, textual notes, prototype objects, and diagrams.  The  file 
squeak.changes holds   a   log  of  any  program  code  you  have 
written. Finally, SqueakV*.sources files are symbolic links to
system-wide files holding program code that is common to all Squeak worlds."

Cheers,
Andreas
(I am not a Debian developer but first got into contact with
Smalltalk-80 in August 1981.)



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#236721; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to "Lex Spoon" <lex@lexspoon.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #48 received at 236721@bugs.debian.org (full text, mbox):

From: "Lex Spoon" <lex@lexspoon.org>
To: 236721@bugs.debian.org
Subject: Re: Bug#236721: Squeak in Debian main
Date: Mon, 12 Jun 2006 09:02:32 +0200
"Andreas Kuckartz" <A.Kuckartz@ping.de> wrote:
> > (4) The distributed files squeak.changes and squeak.image, both around
> > 10MB, are shipped in binary form. I wonder if there should be source
> > code to create them initially. (See DFSG.2, "Source Code")
> 
> The .changes file contains Smalltalk source code (if the system is not
> broken!).
> 
> I think that one can argue that there exists nothing really comparable
> to the .image files used by Smalltalk-80 systems for other programming
> languages. Those .image-files exist since at least 25 years and in my
> opinion they are an important aspect of the Smalltalk-80 way of doing
> things. In some way it is comparable to a living organism.
> 

A key observation for the present discussion: an image/changes pair is a
perfectly valid form of ultimate source code for a Squeak developer. 
There is no earlier, more fundamental source code that Squeak developers
use.  Alan Kay himself hacks image/changes pairs when he develops new
things for Squeak.

The only reason these might not look like source code is that they are
not fully in a text format.  However, there does not seem to be any
fundamental reason to insist that source code is textual.

While I cannot find anything in Debian policy about this (only
discussions of the topic), OSI carefully declines to mention text as
either necessary or sufficient for a definition of source code.  Here is
the relevant part of OSI's open-source definition:

"The program must include source code, and must allow distribution in
source code as well as compiled form. Where some form of a product is
not distributed with source code, there must be a well-publicized means
of obtaining the source code for no more than a reasonable reproduction
cost preferably, downloading via the Internet without charge. The source
code must be the preferred form in which a programmer would modify the
program. Deliberately obfuscated source code is not allowed.
Intermediate forms such as the output of a preprocessor or translator
are not allowed."
(item 2 of OSI's Open Source Definition)

Finally, I cannot resist a followon to Andreas' accurate comments. 
*All* source code is organic, evolving, and comparable to a living
organism.  Not even Linus Torvalds could duplicate Linux if you locked
him in a room with no Internet access.  Code is grown.


-Lex



Reply sent to David Moreno Garza <damog@merkel.debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Kurt Gramlich <kurt@lugrav.de>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #53 received at 236721-done@bugs.debian.org (full text, mbox):

From: David Moreno Garza <damog@merkel.debian.org>
To: 236721-done@bugs.debian.org
Subject: WNPP bug closing
Date: Sat, 16 Jun 2007 11:59:58 -0600
Hello,

This is an automatic mail sent to close the RFP you have reported or 
are involved with.

Your RFP wnpp bug is being closed because of the following reasons:
- It is, as of today, older than 365 days.
- It hasn't had any activity recently.

As this is an automatic procedure, it could of course have something
wrong and probably it would be closing some bugs that are not 
intended by owners and submitters (like you) to be closed, for
example if the RFP is still of your interest, or there has been 
some kind of activity around it. In that case, please reopen the
bug, do it, DO IT NOW! (I don't want to be blamed because of
mass closing and not let people know that they can easily reopen
their bugs ;-).

To re-open it, you simply have to mail control@bugs.debian.org
with a body text like this:

 reopen 236721
 stop

Further comments on the work done in the bug sent to
236721@bugs.debian.org would be truly welcomed.
Anyway, if you have any kind of problems when dealing with
the BTS, feel free to contact me and I'd be more than happy to help
you on this: <damog@debian.org>.

A similar process is being applied to other kind of wnpp bugs.

Thanks for your cooperation,

 -- David Moreno Garza <damog@debian.org>.
 



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 15 Jul 2007 07:27:03 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 02:38:44 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.